﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Tableaux
{
    class Program
    {
        static void Main(string[] args)
        {
            /*
            // Exemples de types composés : les tableaux
            int[] tab1 = { 12, -6, 123, 1, 0, -67 };
            //afficheTableau(tab1);
            int[] tab2 = { -1, 0, 1, 1, 0, 1 };
            Console.WriteLine(produitScalaire(tab1, tab2));
            int[] t = lireTableau(6);
            afficheTableau(t);*/

            // tableaux à deux dimensions
            int[] ligne1 = { 1, 2, 3 };
            int[] ligne2 = { 4, 5, 6 };
            int[][] matrice = { ligne1, ligne2 };
            Console.WriteLine("matrice 1");
            AfficheMatrice(matrice);
            int[] ligne1bis = { 1,2 };
            int[] ligne2bis = { 3,4 };
            int[] ligne3bis = { 5, 6 };
            int[][] matrice2 = { ligne1bis, ligne2bis,ligne3bis };
            Console.WriteLine("matrice 2");
            AfficheMatrice(matrice2);
            AfficheTableau(Colonne(matrice, 0));
            AfficheMatrice(ProduitMatriciel(matrice, matrice2));

            //int[] v = { 0, 1, 0 };
            //int[] produit = ProduitVectoriel(matrice, v);
            //Console.WriteLine("produit vectoriel");
            //AfficheTableau(produit);
            /*int[][] matrice = LireMatrice(2, 3);
            AfficheMatrice(matrice);*/
            Wait();
        }

        static void Wait()
        {
            Console.WriteLine("Enter pour finir");
            Console.ReadLine();
        }

        // demande n entiers à l'utilisateur et renvoie un tableau
        static int[] LireTableau(int n)
        {
            // lit un tableau de taille n
            int[] res = new int[n];
            Console.WriteLine("donnez " + n + "valeurs");
            for (int i = 0; i < n; i++)
            {
                res[i] = Convert.ToInt32(Console.ReadLine());
            }
            return res;
        }

        // lit n tableaux de taille m et les met dans une matrice
        static int[][] LireMatrice(int n, int m)
        {
            // lit un tableau de taille n
            int[][] res = new int[n][];
            Console.WriteLine("lecture d'une matrice " + n + " " + m);
            for (int i = 0; i < n; i++)
            {
                res[i] = LireTableau(m);
            }
            return res;
        }

        // affiche le tableau t
        static void AfficheTableau(int[] t)
        {
            // affiche les éléments sur la même ligne
            for (int i = 0; i < t.Length; i++)
                Console.Write(t[i] + " ");
            // passe à la ligne à la fin
            Console.WriteLine();
        }

        // affiche la matrice m
        static void AfficheMatrice(int[][] m)
        {
            for (int i = 0; i < m.Length; i++)
            {
                for (int j = 0; j < m[0].Length; j++)
                    Console.Write(m[i][j] + " ");
                // on passe à la ligne entre chaque ligne
                Console.WriteLine();
            }
        }

        // produit scalaire de deux vecteurs
        static int ProduitScalaire(int[] v1, int[] v2)
        {
            int res = 0;
            if (v1.Length != v2.Length)
            {
                Console.WriteLine("produit scalaire impossible");
                return -1;
            }
            for (int i = 0; i < v1.Length; i++)
                res += v1[i] * v2[i];
            return res;
        }

        // produit vectoriel d'une matrice et d'un vecteur
        static int[] ProduitVectoriel(int[][] m, int[] v)
        {
            int ligne = m.Length;
            int colonne = m[0].Length;
            int[] res = new int[ligne];
            if (v.Length != colonne)
            {
                Console.WriteLine("produit vectoriel impossible");
                return res;
            }
            for (int i = 0; i < ligne; i++)
               res[i] = ProduitScalaire(m[i], v);
            return res;
        }

        // renvoie un tableau contenant la colone i de la matrice m
        static int[] Colonne(int[][] m,int c)
        {
            int[] t = new int[m.Length];
            for (int i=0;i<m.Length;i++)
            {
                t[i] = m[i][c];
            }
            return t;
        }
 
        // produit matriciel de deux matrices
        static int[][] ProduitMatriciel(int[][] m1, int[][] m2)
        {
             if (m1[0].Length != m2.Length)
            {
                Console.WriteLine("produit matriciel impossible");
                return null;
            }
            int ligne = m1.Length;
            int colonne = m2[0].Length;
            int[][] res = new int[ligne][];
            for (int i = 0; i < ligne; i++)
            {
                res[i] = new int[colonne];
                for (int j = 0; j < colonne; j++)
                    res[i][j] = ProduitScalaire(m1[i], Colonne(m2, j));
            }
            return res;
        }
    }
}

